Index: src/Actions/MoleculeAction/FillWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,21 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/FillWithMoleculeAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "atom.hpp"
+#include "bondgraph.hpp"
+#include "boundary.hpp"
+#include "config.hpp"
+#include "molecule.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
 
 #include <iostream>
@@ -17,16 +31,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
-
-#include "atom.hpp"
-#include "bondgraph.hpp"
-#include "boundary.hpp"
-#include "config.hpp"
-#include "defs.hpp"
-#include "molecule.hpp"
-#include "periodentafel.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
-#include "World.hpp"
+#include "Actions/ValueStorage.hpp"
 
 /****** MoleculeFillWithMoleculeAction *****/
@@ -53,7 +56,27 @@
 {}
 
+void MoleculeFillWithMolecule(std::string &fillername, Vector &distances, Vector &lengths, double MaxDistance, bool DoRotate) {
+  ValueStorage::getInstance().setCurrentValue(MoleculeFillWithMoleculeAction::NAME, fillername);
+  ValueStorage::getInstance().setCurrentValue("distances", distances);
+  ValueStorage::getInstance().setCurrentValue("lengths", lengths);
+  ValueStorage::getInstance().setCurrentValue("DoRotate", MaxDistance);
+  ValueStorage::getInstance().setCurrentValue("MaxDistance", DoRotate);
+  ActionRegistry::getInstance().getActionByName(MoleculeFillWithMoleculeAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* MoleculeFillWithMoleculeAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+  dialog->queryVector("distances", false, ValueStorage::getInstance().getDescription("distances"));
+  dialog->queryVector("lengths", false, ValueStorage::getInstance().getDescription("lengths"));
+  dialog->queryBoolean("DoRotate", ValueStorage::getInstance().getDescription("DoRotate"));
+  dialog->queryDouble("MaxDistance", ValueStorage::getInstance().getDescription("MaxDistance"));
+
+  return dialog;
+}
+
 Action::state_ptr MoleculeFillWithMoleculeAction::performCall() {
   string filename;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   Vector distances;
   Vector lengths;
@@ -61,19 +84,18 @@
   bool DoRotate = false;
 
-  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryVector("distances", &distances, World::getInstance().getDomain(), false, MapOfActions::getInstance().getDescription("distances"));
-  dialog->queryVector("lengths", &lengths, World::getInstance().getDomain(), false, MapOfActions::getInstance().getDescription("lengths"));
-  dialog->queryBoolean("DoRotate", &DoRotate, MapOfActions::getInstance().getDescription("DoRotate"));
-  dialog->queryDouble("MaxDistance", &MaxDistance, MapOfActions::getInstance().getDescription("MaxDistance"));
+  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
+  ValueStorage::getInstance().queryCurrentValue("distances", distances);
+  ValueStorage::getInstance().queryCurrentValue("lengths", lengths);
+  ValueStorage::getInstance().queryCurrentValue("DoRotate", DoRotate);
+  ValueStorage::getInstance().queryCurrentValue("MaxDistance", MaxDistance);
 
-  if(dialog->display()) {
-    DoLog(1) && (Log() << Verbose(1) << "Filling Box with water molecules, lengths(" << lengths[0] << "," << lengths[1] << "," << lengths[2] << "), distances (" << distances[0] << "," << distances[1] << "," << distances[2] << "), MaxDistance " << MaxDistance << ", DoRotate " << DoRotate << "." << endl);
-    // construct water molecule
-    molecule *filler = World::getInstance().createMolecule();
-    if (!filler->AddXYZFile(filename)) {
-      DoeLog(0) && (eLog()<< Verbose(0) << "Could not parse filler molecule from " << filename << "." << endl);
-    }
-    filler->SetNameFromFilename(filename.c_str());
-    molecule *Filling = NULL;
+  DoLog(1) && (Log() << Verbose(1) << "Filling Box with water molecules, lengths(" << lengths[0] << "," << lengths[1] << "," << lengths[2] << "), distances (" << distances[0] << "," << distances[1] << "," << distances[2] << "), MaxDistance " << MaxDistance << ", DoRotate " << DoRotate << "." << endl);
+  // construct water molecule
+  molecule *filler = World::getInstance().createMolecule();
+  if (!filler->AddXYZFile(filename)) {
+    DoeLog(0) && (eLog()<< Verbose(0) << "Could not parse filler molecule from " << filename << "." << endl);
+  }
+  filler->SetNameFromFilename(filename.c_str());
+  molecule *Filling = NULL;
 //    atom *first = NULL, *second = NULL, *third = NULL;
 //    first = World::getInstance().createAtom();
@@ -91,27 +113,23 @@
 //    filler->AddBond(first, third, 1);
 //    filler->AddBond(second, third, 1);
-    World::getInstance().getConfig()->BG->ConstructBondGraph(filler);
+  World::getInstance().getConfig()->BG->ConstructBondGraph(filler);
 //    filler->SetNameFromFilename("water");
-    // call routine
-    double distance[NDIM];
-    for (int i=0;i<NDIM;i++)
-      distance[i] = distances[i];
-    Filling = FillBoxWithMolecule(World::getInstance().getMolecules(), filler, *(World::getInstance().getConfig()), MaxDistance, distance, lengths[0], lengths[1], lengths[2], DoRotate);
-    if (Filling != NULL) {
-      Filling->ActiveFlag = false;
-      World::getInstance().getMolecules()->insert(Filling);
-    }
-    for (molecule::iterator iter = filler->begin(); !filler->empty(); iter = filler->begin()) {
-      atom *Walker = *iter;
-      filler->erase(iter);
-      World::getInstance().destroyAtom(Walker);
-    }
-    World::getInstance().destroyMolecule(filler);
+  // call routine
+  double distance[NDIM];
+  for (int i=0;i<NDIM;i++)
+    distance[i] = distances[i];
+  Filling = FillBoxWithMolecule(World::getInstance().getMolecules(), filler, *(World::getInstance().getConfig()), MaxDistance, distance, lengths[0], lengths[1], lengths[2], DoRotate);
+  if (Filling != NULL) {
+    Filling->ActiveFlag = false;
+    World::getInstance().getMolecules()->insert(Filling);
+  }
+  for (molecule::iterator iter = filler->begin(); !filler->empty(); iter = filler->begin()) {
+    atom *Walker = *iter;
+    filler->erase(iter);
+    World::getInstance().destroyAtom(Walker);
+  }
+  World::getInstance().destroyMolecule(filler);
 
-    delete dialog;
-    return Action::success;
-  }
-  delete dialog;
-  return Action::failure;
+  return Action::success;
 }
 
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.hpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+#include "LinearAlgebra/Vector.hpp"
 
 class MoleculeListClass;
 
+void MoleculeFillWithMolecule(std::string &fillername, Vector &distances, Vector &lengths, double MaxDistance, bool DoRotate);
+
 class MoleculeFillWithMoleculeAction : public Action {
+  friend void MoleculeFillWithMolecule(std::string &fillername, Vector &distances, Vector &lengths, double MaxDistance, bool DoRotate);
+
 public:
   MoleculeFillWithMoleculeAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp
===================================================================
--- src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,19 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "atom.hpp"
+#include "defs.hpp"
+#include "Helpers/Log.hpp"
+#include "molecule.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
 
 #include <iostream>
@@ -18,12 +30,6 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
+#include "Actions/ValueStorage.hpp"
 
-#include "atom.hpp"
-#include "defs.hpp"
-#include "log.hpp"
-#include "molecule.hpp"
-#include "verbose.hpp"
-#include "World.hpp"
 
 /****** MoleculeLinearInterpolationofTrajectoriesAction *****/
@@ -50,7 +56,25 @@
 {}
 
+void MoleculeLinearInterpolationofTrajectories(std::string &filename, int start, int end, bool IdMapping) {
+  ValueStorage::getInstance().setCurrentValue(MoleculeLinearInterpolationofTrajectoriesAction::NAME, filename);
+  ValueStorage::getInstance().setCurrentValue("start-step", start);
+  ValueStorage::getInstance().setCurrentValue("end-step", end);
+  ValueStorage::getInstance().setCurrentValue("id-mapping", IdMapping);
+  ActionRegistry::getInstance().getActionByName(MoleculeLinearInterpolationofTrajectoriesAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* MoleculeLinearInterpolationofTrajectoriesAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+  dialog->queryInt("start-step", ValueStorage::getInstance().getDescription("start-step"));
+  dialog->queryInt("end-step", ValueStorage::getInstance().getDescription("end-step"));
+  dialog->queryBoolean("id-mapping", ValueStorage::getInstance().getDescription("id-mapping"));
+
+  return dialog;
+}
+
 Action::state_ptr MoleculeLinearInterpolationofTrajectoriesAction::performCall() {
   string filename;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   molecule *mol = NULL;
   int start = -1;
@@ -58,12 +82,11 @@
   bool IdMapping = true;
 
+  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
+  ValueStorage::getInstance().queryCurrentValue("start-step", start);
+  ValueStorage::getInstance().queryCurrentValue("end-step", end);
+  ValueStorage::getInstance().queryCurrentValue("id-mapping", IdMapping);
 
-  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryInt("start-step", &start, MapOfActions::getInstance().getDescription("start-step"));
-  dialog->queryInt("end-step", &end, MapOfActions::getInstance().getDescription("end-step"));
-  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
-  dialog->queryBoolean("id-mapping", &IdMapping, MapOfActions::getInstance().getDescription("id-mapping"));
-
-  if(dialog->display()) {
+  for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    mol = iter->second;
     DoLog(1) && (Log() << Verbose(1) << "Linear interpolation between configuration " << start << " and " << end << "." << endl);
     if (IdMapping)
@@ -73,9 +96,6 @@
     else
       DoLog(2) && (Log() << Verbose(2) << "Steps created and " << filename << " files stored." << endl);
-    delete dialog;
-    return Action::success;
   }
-  delete dialog;
-  return Action::failure;
+  return Action::success;
 }
 
Index: src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp
===================================================================
--- src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
 
 class MoleculeListClass;
 
+void MoleculeLinearInterpolationofTrajectories(std::string &filename, int start, int end, bool IdMapping);
+
 class MoleculeLinearInterpolationofTrajectoriesAction : public Action {
+  friend void MoleculeLinearInterpolationofTrajectories(std::string &filename, int start, int end, bool IdMapping);
+
 public:
   MoleculeLinearInterpolationofTrajectoriesAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/MoleculeAction/RotateAroundSelfByAngleAction.cpp
===================================================================
--- src/Actions/MoleculeAction/RotateAroundSelfByAngleAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/MoleculeAction/RotateAroundSelfByAngleAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,148 @@
+/*
+ * RotateAroundSelfByAngleAction.cpp
+ *
+ *  Created on: Aug 06, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Actions/MoleculeAction/RotateAroundSelfByAngleAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Line.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "atom.hpp"
+#include "molecule.hpp"
+
+
+#include <iostream>
+#include <fstream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+/****** MoleculeRotateAroundSelfByAngleAction *****/
+
+// memento to remember the state when undoing
+
+class MoleculeRotateAroundSelfByAngleState : public ActionState {
+public:
+    MoleculeRotateAroundSelfByAngleState(molecule * const _mol, const Vector &_Axis, const double _alpha) :
+      mol(_mol),
+      Axis(_Axis),
+      alpha(_alpha)
+    {}
+    molecule* const mol;
+    Vector Axis;
+    double alpha;
+};
+
+const char MoleculeRotateAroundSelfByAngleAction::NAME[] = "rotate-self";
+
+MoleculeRotateAroundSelfByAngleAction::MoleculeRotateAroundSelfByAngleAction() :
+  Action(NAME)
+{}
+
+MoleculeRotateAroundSelfByAngleAction::~MoleculeRotateAroundSelfByAngleAction()
+{}
+
+void MoleculeRotateAroundSelfByAngle(const Vector &Axis, const double angle) {
+  ValueStorage::getInstance().setCurrentValue(MoleculeRotateAroundSelfByAngleAction::NAME, angle);
+  ValueStorage::getInstance().setCurrentValue("position", Axis);
+  ActionRegistry::getInstance().getActionByName(MoleculeRotateAroundSelfByAngleAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* MoleculeRotateAroundSelfByAngleAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryDouble(NAME, ValueStorage::getInstance().getDescription(NAME));
+  dialog->queryVector("position", false, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
+Action::state_ptr MoleculeRotateAroundSelfByAngleAction::performCall() {
+  molecule *mol = NULL;
+  double alpha = 0.;
+  Vector Axis;
+
+  // obtain angle and axis around which rotate
+  ValueStorage::getInstance().queryCurrentValue(NAME, alpha);
+  ValueStorage::getInstance().queryCurrentValue("position", Axis);
+
+  // check whether a single atom and molecule is selected
+  if (World::getInstance().getSelectedMolecules().size() != 1)
+    return Action::failure;
+  mol = World::getInstance().beginMoleculeSelection()->second;
+
+  // check whether Axis is valid
+  if (Axis.IsZero())
+    return Action::failure;
+
+  // convert from degrees to radian
+  alpha *= M_PI/180.;
+
+  // Creation Line that is the rotation axis
+  Vector *CenterOfGravity = mol->DetermineCenterOfGravity();
+  Line RotationAxis(*CenterOfGravity, Axis);
+  delete(CenterOfGravity);
+  DoLog(0) && (Log() << Verbose(0) << "Rotate around self by " << alpha << " along " << RotationAxis << "." << endl);
+
+  for (molecule::iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), alpha));
+  }
+  DoLog(0) && (Log() << Verbose(0) << "done." << endl);
+
+  return Action::state_ptr(new MoleculeRotateAroundSelfByAngleState(mol, Axis, alpha));
+}
+
+Action::state_ptr MoleculeRotateAroundSelfByAngleAction::performUndo(Action::state_ptr _state) {
+  MoleculeRotateAroundSelfByAngleState *state = assert_cast<MoleculeRotateAroundSelfByAngleState*>(_state.get());
+
+  Vector *CenterOfGravity = state->mol->DetermineCenterOfGravity();
+  Line RotationAxis(*CenterOfGravity, state->Axis);
+  delete(CenterOfGravity);
+
+  for (molecule::iterator iter = state->mol->begin(); iter != state->mol->end(); ++iter) {
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), -state->alpha));
+  }
+
+  return Action::state_ptr(_state);
+}
+
+Action::state_ptr MoleculeRotateAroundSelfByAngleAction::performRedo(Action::state_ptr _state){
+  MoleculeRotateAroundSelfByAngleState *state = assert_cast<MoleculeRotateAroundSelfByAngleState*>(_state.get());
+
+  Vector *CenterOfGravity = state->mol->DetermineCenterOfGravity();
+  Line RotationAxis(*CenterOfGravity, state->Axis);
+  delete(CenterOfGravity);
+
+  for (molecule::iterator iter = state->mol->begin(); iter != state->mol->end(); ++iter) {
+    (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), state->alpha));
+  }
+
+  return Action::state_ptr(_state);
+}
+
+bool MoleculeRotateAroundSelfByAngleAction::canUndo() {
+  return true;
+}
+
+bool MoleculeRotateAroundSelfByAngleAction::shouldUndo() {
+  return true;
+}
+
+const string MoleculeRotateAroundSelfByAngleAction::getName() {
+  return NAME;
+}
Index: src/Actions/MoleculeAction/RotateAroundSelfByAngleAction.hpp
===================================================================
--- src/Actions/MoleculeAction/RotateAroundSelfByAngleAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Actions/MoleculeAction/RotateAroundSelfByAngleAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,40 @@
+/*
+ * RotateAroundSelfByAngleAction.hpp
+ *
+ *  Created on: Aug 06, 2010
+ *      Author: heber
+ */
+
+#ifndef ROTATEAROUNDSELFBYANGLEACTION_HPP
+#define ROTATEAROUNDSELFBYANGLEACTION_HPP
+
+#include "Actions/Action.hpp"
+
+class MoleculeListClass;
+class Vector;
+
+void MoleculeRotateOrigin(Vector &Axis);
+
+class MoleculeRotateAroundSelfByAngleAction : public Action {
+  friend void MoleculeRotateAroundSelfByAngle(const Vector &Axis, const double angle);
+
+public:
+  MoleculeRotateAroundSelfByAngleAction();
+  virtual ~MoleculeRotateAroundSelfByAngleAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+
+#endif // ROTATEAROUNDSELFBYANGLEACTION_HPP
Index: src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.cpp
===================================================================
--- src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,21 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Line.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "element.hpp"
+#include "molecule.hpp"
+
 
 #include <iostream>
@@ -18,9 +32,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
-
-#include "log.hpp"
-#include "molecule.hpp"
-#include "verbose.hpp"
+#include "Actions/ValueStorage.hpp"
 
 /****** MoleculeRotateToPrincipalAxisSystemAction *****/
@@ -47,18 +57,106 @@
 {}
 
+void MoleculeRotateToPrincipalAxisSystem(Vector &Axis) {
+  ValueStorage::getInstance().setCurrentValue(MoleculeRotateToPrincipalAxisSystemAction::NAME, Axis);
+  ActionRegistry::getInstance().getActionByName(MoleculeRotateToPrincipalAxisSystemAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* MoleculeRotateToPrincipalAxisSystemAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryVector(NAME, false, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr MoleculeRotateToPrincipalAxisSystemAction::performCall() {
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   molecule *mol = NULL;
+  Vector Axis;
 
-  dialog->queryMolecule(NAME, &mol, MapOfActions::getInstance().getDescription(NAME));
+  // obtain axis to rotate to
+  ValueStorage::getInstance().queryCurrentValue(NAME, Axis);
 
-  if(dialog->display()) {
+  for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    mol = iter->second;
     DoLog(0) && (Log() << Verbose(0) << "Converting to prinicipal axis system." << endl);
-    mol->PrincipalAxisSystem(true);
-    delete dialog;
-    return Action::success;
+    Matrix InertiaTensor;
+    Vector *CenterOfGravity = mol->DetermineCenterOfGravity();
+
+    // reset inertia tensor
+    InertiaTensor.zero();
+
+    // sum up inertia tensor
+    for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+      Vector x = (*iter)->getPosition();
+      x -= *CenterOfGravity;
+      const double mass = (*iter)->getType()->mass;
+      InertiaTensor.at(0,0) += mass*(x[1]*x[1] + x[2]*x[2]);
+      InertiaTensor.at(0,1) += mass*(-x[0]*x[1]);
+      InertiaTensor.at(0,2) += mass*(-x[0]*x[2]);
+      InertiaTensor.at(1,0) += mass*(-x[1]*x[0]);
+      InertiaTensor.at(1,1) += mass*(x[0]*x[0] + x[2]*x[2]);
+      InertiaTensor.at(1,2) += mass*(-x[1]*x[2]);
+      InertiaTensor.at(2,0) += mass*(-x[2]*x[0]);
+      InertiaTensor.at(2,1) += mass*(-x[2]*x[1]);
+      InertiaTensor.at(2,2) += mass*(x[0]*x[0] + x[1]*x[1]);
+    }
+    // print InertiaTensor for debugging
+    DoLog(0) && (Log() << Verbose(0) << "The inertia tensor is:" << InertiaTensor << endl);
+
+    // diagonalize to determine principal axis system
+    Vector Eigenvalues = InertiaTensor.transformToEigenbasis();
+
+    for(int i=0;i<NDIM;i++)
+      DoLog(0) && (Log() << Verbose(0) << "eigenvalue = " << Eigenvalues[i] << ", eigenvector = " << InertiaTensor.column(i) << endl);
+
+    // check whether we rotate or not
+    DoLog(0) && (Log() << Verbose(0) << "Transforming molecule into PAS ... ");
+
+    // obtain first column, eigenvector to biggest eigenvalue
+    Vector BiggestEigenvector(InertiaTensor.column(Eigenvalues.SmallestComponent()));
+    Vector DesiredAxis(Axis);
+
+    // Creation Line that is the rotation axis
+    DesiredAxis.VectorProduct(BiggestEigenvector);
+    Line RotationAxis(Vector(0.,0.,0.), DesiredAxis);
+
+    // determine angle
+    const double alpha = BiggestEigenvector.Angle(Axis);
+
+    DoLog(0) && (Log() << Verbose(0) << alpha << endl);
+
+    for (molecule::iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+      *(*iter) -= *CenterOfGravity;
+      (*iter)->setPosition(RotationAxis.rotateVector((*iter)->getPosition(), alpha));
+      *(*iter) += *CenterOfGravity;
+    }
+    DoLog(0) && (Log() << Verbose(0) << "done." << endl);
+
+    // summing anew for debugging (resulting matrix has to be diagonal!)
+    // reset inertia tensor
+    InertiaTensor.zero();
+
+    // sum up inertia tensor
+    for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+      Vector x = (*iter)->getPosition();
+      x -= *CenterOfGravity;
+      const double mass = (*iter)->getType()->mass;
+      InertiaTensor.at(0,0) += mass*(x[1]*x[1] + x[2]*x[2]);
+      InertiaTensor.at(0,1) += mass*(-x[0]*x[1]);
+      InertiaTensor.at(0,2) += mass*(-x[0]*x[2]);
+      InertiaTensor.at(1,0) += mass*(-x[1]*x[0]);
+      InertiaTensor.at(1,1) += mass*(x[0]*x[0] + x[2]*x[2]);
+      InertiaTensor.at(1,2) += mass*(-x[1]*x[2]);
+      InertiaTensor.at(2,0) += mass*(-x[2]*x[0]);
+      InertiaTensor.at(2,1) += mass*(-x[2]*x[1]);
+      InertiaTensor.at(2,2) += mass*(x[0]*x[0] + x[1]*x[1]);
+      // print InertiaTensor for debugging
+      DoLog(0) && (Log() << Verbose(0) << "The inertia tensor is:" << InertiaTensor << endl);
+    }
+
+    // free everything
+    delete(CenterOfGravity);
   }
-  delete dialog;
-  return Action::failure;
+  return Action::success;
 }
 
Index: src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp
===================================================================
--- src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
 
 class MoleculeListClass;
+class Vector;
+
+void MoleculeRotateToPrincipalAxisSystem(Vector &Axis);
 
 class MoleculeRotateToPrincipalAxisSystemAction : public Action {
+  friend void MoleculeRotateToPrincipalAxisSystem(Vector &Axis);
+
 public:
   MoleculeRotateToPrincipalAxisSystemAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
Index: src/Actions/MoleculeAction/SaveAdjacencyAction.cpp
===================================================================
--- src/Actions/MoleculeAction/SaveAdjacencyAction.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/SaveAdjacencyAction.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,20 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/MoleculeAction/SaveAdjacencyAction.hpp"
+#include "Actions/ActionRegistry.hpp"
+#include "bondgraph.hpp"
+#include "config.hpp"
+#include "Helpers/Log.hpp"
+#include "molecule.hpp"
+#include "Helpers/Verbose.hpp"
+#include "World.hpp"
+
 
 #include <iostream>
@@ -18,15 +31,5 @@
 #include "UIElements/UIFactory.hpp"
 #include "UIElements/Dialog.hpp"
-#include "Actions/MapOfActions.hpp"
-
-#include "atom.hpp"
-#include "bondgraph.hpp"
-#include "config.hpp"
-#include "defs.hpp"
-#include "log.hpp"
-#include "molecule.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
-#include "World.hpp"
+#include "Actions/ValueStorage.hpp"
 
 /****** MoleculeSaveAdjacencyAction *****/
@@ -53,22 +56,31 @@
 {}
 
+void MoleculeSaveAdjacency(std::string &adjacencyfile) {
+  ValueStorage::getInstance().setCurrentValue(MoleculeSaveAdjacencyAction::NAME, adjacencyfile);
+  ActionRegistry::getInstance().getActionByName(MoleculeSaveAdjacencyAction::NAME)->call(Action::NonInteractive);
+};
+
+Dialog* MoleculeSaveAdjacencyAction::fillDialog(Dialog *dialog) {
+  ASSERT(dialog,"No Dialog given when filling action dialog");
+
+  dialog->queryString(NAME, ValueStorage::getInstance().getDescription(NAME));
+
+  return dialog;
+}
+
 Action::state_ptr MoleculeSaveAdjacencyAction::performCall() {
   string filename;
-  Dialog *dialog = UIFactory::getInstance().makeDialog();
   molecule *mol = NULL;
 
-  dialog->queryString(NAME, &filename, MapOfActions::getInstance().getDescription(NAME));
-  dialog->queryMolecule("molecule-by-id", &mol, MapOfActions::getInstance().getDescription("molecule-by-id"));
+  ValueStorage::getInstance().queryCurrentValue(NAME, filename);
 
-  if(dialog->display()) {
+  for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
+    mol = iter->second;
     DoLog(0) && (Log() << Verbose(0) << "Storing adjacency to path " << filename << "." << endl);
     World::getInstance().getConfig()->BG->ConstructBondGraph(mol);
     // TODO: sollte stream nicht filename benutzen, besser fuer unit test
     mol->StoreAdjacencyToFile(filename);
-    delete dialog;
-    return Action::success;
   }
-  delete dialog;
-  return Action::failure;
+  return Action::success;
 }
 
Index: src/Actions/MoleculeAction/SaveAdjacencyAction.hpp
===================================================================
--- src/Actions/MoleculeAction/SaveAdjacencyAction.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Actions/MoleculeAction/SaveAdjacencyAction.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,9 +10,13 @@
 
 #include "Actions/Action.hpp"
-#include "Actions/Process.hpp"
+
 
 class MoleculeListClass;
 
+void MoleculeSaveAdjacency(std::string &adjacencyfile);
+
 class MoleculeSaveAdjacencyAction : public Action {
+  friend void MoleculeSaveAdjacency(std::string &adjacencyfile);
+
 public:
   MoleculeSaveAdjacencyAction();
@@ -23,4 +27,6 @@
 
   virtual const std::string getName();
+protected:
+  virtual Dialog * fillDialog(Dialog *dialog);
 private:
   virtual Action::state_ptr performCall();
